/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss10.mancala;
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Mancala
{


   /**
    * <pre>
    *           0..1     activePlayer     0..1
    * Mancala ------------------------> Player
    *           mancala2               activePlayer
    * </pre>
    */

   private Player activePlayer;

   public boolean setActivePlayer (Player value)
   {
      boolean changed = false;

      if (this.activePlayer != value)
      {
      
         Player oldValue = this.activePlayer;
         this.activePlayer = value;
         changed = true;
      
      }
      return changed;
   }

   public Mancala withActivePlayer (Player value)
   {
      setActivePlayer (value);
      return this;
   }

   public Player getActivePlayer ()
   {
      return this.activePlayer;
   }

   public void checkEnd ()
   {
   }

   public void initGame (String firstPlayerName , String secondPlayerName )
   {
	   // Create the two players and add them to mancala
	   Player firstPlayer = new Player();
	   firstPlayer.setName(firstPlayerName);
	   
	   Player secondPlayer = new Player();
	   secondPlayer.setName(secondPlayerName);
	   
	   addToPlayer(firstPlayer);
	   addToPlayer(secondPlayer);
	   
	   // Create the pits for the secondplayer (nr. 1-6)
	   Pit lastCreatedPit = createPitRow(firstPlayer, null, 1);
	   
	   // Create the first players Kalah
	   lastCreatedPit = createKalah(
			   				firstPlayer, 
			   				lastCreatedPit, 
			   				42); // Number doesn't really matter here...
	   
	   // Create the pits for the secondplayer (nr. 7-12)
	   lastCreatedPit = createPitRow(secondPlayer, lastCreatedPit, 7);
	   
	   // Create the second players Kalah
	   Kalah secondPlayersKalah = createKalah(secondPlayer, lastCreatedPit, 21);
	   
	   // Connect the second players Kalah with the first pit
	   secondPlayersKalah.setNext(getFromPit(1));
	   
	   // Last step: create counterpart links
	   Pit first = getFromPit(1);
	   Pit second = getFromPit(12);
	   first.setCounterpart(second);
	   for(int i=0; i<5; i++)
	   {
		   first = first.getNext();
		   second = second.getPrevious();
		   first.setCounterpart(second);
	   }
	   
	   // Let the first player begin
	   setActivePlayer(firstPlayer);
   }

	private Kalah createKalah(Player firstPlayer, Pit lastCreatedPit, int nr) {
		Kalah kalah = new Kalah();
		kalah.setNr(nr); 
		kalah.setPrevious(lastCreatedPit);
		firstPlayer.setKalah(kalah);
		
		addToPit(kalah);
		return kalah;
	}

	private Pit createPitRow(Player player, Pit lastCreatedPit, int startNr) 
	{
		int index = startNr;
		// Create the pits for the first player
		// We start with the part from the bottom left
		for (int i = 0; i < 6; i++) {
			Pit nextPit = new Pit();
			nextPit.setNr(index);

			// Connect the pit to the previous one
			nextPit.setPrevious(lastCreatedPit);

			// Create four stones for each pit
			for (int j = 0; j < 4; j++) {
				Stone stone = new Stone();
				nextPit.addToStones(stone);
			}

			// Add the pit to the mancala
			addToPit(nextPit);
			// Add the pit to the firstPlayer
			player.addToPits(nextPit);

			lastCreatedPit = nextPit;
			index++;
		}
		return lastCreatedPit;
	}

   /**
    * <pre>
    *           0..1     pit     0..1
    * Mancala ------------------------- Pit
    *           mancala               pit
    * </pre>
    */

   private FHashMap pit;

   public Collection<Pit> getPit()
   {
      if (pit != null)
      {
         return (Collection<Pit>) Collections.unmodifiableMap(pit);
      }
      else 
      {
         return FEmptySet.get();
      }
   }

   public boolean addToPit (Pit value)
   {
      return this.addToPit (getKeyForPit (value), value);
   }

   public Mancala withPit (Pit value)
   {
      addToPit (value);
      return this;
   }

   public Mancala withoutPit (Pit value)
   {
      removeFromPit (value);
      return this;
   }


   public boolean removeFromPit (Pit value)
   {
      return removeFromPit (getKeyForPit (value), value);
   }

   public void removeAllFromPit ()
   {
   
      Iterator iter = entriesOfPit ();
      Map.Entry entry;
      while (iter.hasNext ())
      {
         entry = (Map.Entry) iter.next ();
         removeFromPit ((Integer) entry.getKey (), (Pit) entry.getValue ());
      }
   }

   public boolean hasInPit (Pit value)
   {
      return (this.hasInPit (this.getKeyForPit (value), value));
   }

   public Iterator iteratorOfPit ()
   {
      return ((this.pit == null)
              ? FEmptyIterator.get ()
              : this.pit.values ().iterator ());
   }

   public int sizeOfPit ()
   {
      return ((this.pit == null)
              ? 0
              : this.pit.size ());
   }

   public boolean hasInPit (int key, Pit value)
   {
      return ((this.pit != null) &&
              (value != null || this.pit.containsKey (key)) && 
              (this.pit.get (key) == value));
   }

   public boolean hasKeyInPit (int key)
   {
      return ((this.pit != null) &&
              this.pit.containsKey (key));
   }

   public Iterator keysOfPit ()
   {
      return ((this.pit == null)
              ? FEmptyIterator.get ()
              : this.pit.keySet ().iterator ());
   }

   public Iterator entriesOfPit ()
   {
      return ((this.pit == null)
              ? FEmptyIterator.get ()
              : this.pit.entrySet ().iterator ());
   }

   protected boolean addToPit (int key, Pit value)
   {
      boolean changed = false;

      if (this.pit == null)
      {
         this.pit = new FHashMap ();
      }
   
      Pit oldValue = (Pit) this.pit.put (key, value);
      if (oldValue != value)
      {
         if (oldValue != null)
         {
            oldValue.setMancala (null);
         }
         if (value != null)
         {
            value.setMancala (this);
         }
         changed = true;
      }
   
      return changed;
   }

   protected boolean addToPit (Map.Entry entry)
   {
      return addToPit ((Integer) entry.getKey (), (Pit) entry.getValue ());
   }

   protected boolean removeFromPit (int key, Pit value)
   {
      boolean changed = false;

      if (this.pit != null)
      {
         Pit oldValue = (Pit) this.pit.get (key);
         if (oldValue == value && 
             (oldValue != null || this.pit.containsKey (key)))
         {
         
            this.pit.remove (key);
            if (value != null)
            {
               value.setMancala (null);
            }
            changed = true;
         
         }
      }
      return changed;
   }

   public boolean removeKeyFromPit (int key)
   {
      boolean changed = false;

      if (this.pit != null)
      {
         changed = this.pit.containsKey (key);
         if (changed)
         {
         
            Pit tmpValue = (Pit) this.pit.remove (key);
            if (tmpValue != null)
            {
               tmpValue.setMancala (null);
            }
         
         }
      }
      return changed;
   }
   public Pit getFromPit (int key)
   {
      return ((this.pit == null)
              ? null
              : (Pit) this.pit.get (key));
   }
   public int getKeyForPit (Pit value)
   {
      return (value == null ? null : value.getNr ());
   }

   public void keyChangedInPit (int oldKey, Pit value)
   {
      if ((this.pit != null) &&  
          (oldKey != getKeyForPit (value)))
      {
         Pit oldValue = (Pit) this.pit.get (oldKey);
         if (oldValue == value)
         {
            this.pit.remove (oldKey);
            oldValue = (Pit)this.pit.put (this.getKeyForPit (value), value);
            if (oldValue != null)
            {
               oldValue.setMancala (null);
            }
         }
      }
   }

   /**
    * <pre>
    *           0..1     player     0..n
    * Mancala ------------------------- Player
    *           mancala               player
    * </pre>
    */

   private FHashSet player;

   public Collection<Player> getPlayer()
   {
      if (player != null)
      {
         return Collections.unmodifiableCollection(player);
      }
      else 
      {
         return FEmptySet.get();
      }
   }

   public boolean addToPlayer (Player value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.player == null)
         {
            this.player = new FHashSet ();

         }
      
         changed = this.player.add (value);
         if (changed)
         {
            value.setMancala (this);
         }
      
      }
      return changed;
   }

   public Mancala withPlayer (Player value)
   {
      addToPlayer (value);
      return this;
   }

   public Mancala withoutPlayer (Player value)
   {
      removeFromPlayer (value);
      return this;
   }


   public boolean removeFromPlayer (Player value)
   {
      boolean changed = false;

      if ((this.player != null) && (value != null))
      {
      
         changed = this.player.remove (value);
         if (changed)
         {
            value.setMancala (null);
         }
      
      }
      return changed;
   }

   public void removeAllFromPlayer ()
   {
   
      Player tmpValue;
      Iterator iter = this.iteratorOfPlayer ();

      while (iter.hasNext ())
      {
         tmpValue = (Player) iter.next ();
         this.removeFromPlayer (tmpValue);
      }
   
   }

   public boolean hasInPlayer (Player value)
   {
      return ((this.player != null) &&
              (value != null) &&
              this.player.contains (value));
   }

   public Iterator iteratorOfPlayer ()
   {
      return ((this.player == null)
              ? FEmptyIterator.get ()
              : this.player.iterator ());
   }

   public int sizeOfPlayer ()
   {
      return ((this.player == null)
              ? 0
              : this.player.size ());
   }

   /**
    * <pre>
    *           0..1     winner     0..1
    * Mancala ------------------------> Player
    *           mancala3               winner
    * </pre>
    */

   private Player winner;

   public boolean setWinner (Player value)
   {
      boolean changed = false;

      if (this.winner != value)
      {
      
         Player oldValue = this.winner;
         this.winner = value;
         changed = true;
      
      }
      return changed;
   }

   public Mancala withWinner (Player value)
   {
      setWinner (value);
      return this;
   }

   public Player getWinner ()
   {
      return this.winner;
   }

   public void removeYou()
   {
      this.setActivePlayer (null);
      this.removeAllFromPit ();
      this.removeAllFromPlayer ();
      this.setWinner (null);
   }
}


